import * as graphsearchrpc_grpc_pb from "../pb/graphsearchrpc_grpc_pb";
import * as graphsearchrpc_pb from "../pb/graphsearchrpc_pb";
interface IGraphSearchParameters {
    hash: string;
    reversedHashOrder?: boolean;
    excludeList?: string[];
}
interface ITrustedValidationParameters {
    hash: string;
    reversedHashOrder?: boolean;
}
export declare class GraphSearchClient {
    client: graphsearchrpc_grpc_pb.GraphSearchServiceClient;
    constructor({ url, rootCertPath, options, notls }?: {
        url?: string;
        rootCertPath?: string;
        testnet?: boolean;
        options?: object;
        notls?: boolean;
    });
    graphSearchFor({ hash, reversedHashOrder, excludeList }: IGraphSearchParameters): Promise<graphsearchrpc_pb.GraphSearchReply>;
    trustedValidationFor({ hash, reversedHashOrder }: ITrustedValidationParameters): Promise<graphsearchrpc_pb.TrustedValidationReply>;
    getStatus(): Promise<graphsearchrpc_pb.StatusReply>;
}
export {};
