"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GraphSearchClient = void 0;
var fs = __importStar(require("fs"));
var grpc = __importStar(require("grpc"));
var graphsearchrpc_grpc_pb = __importStar(require("../pb/graphsearchrpc_grpc_pb"));
var graphsearchrpc_pb = __importStar(require("../pb/graphsearchrpc_pb"));
var GraphSearchClient = /** @class */ (function () {
    function GraphSearchClient(_a) {
        var _b = _a === void 0 ? {} : _a, url = _b.url, rootCertPath = _b.rootCertPath, options = _b.options, notls = _b.notls;
        var creds = grpc.credentials.createSsl();
        if (rootCertPath) {
            var rootCert = fs.readFileSync(rootCertPath);
            creds = grpc.credentials.createSsl(rootCert);
        }
        else if (notls) {
            creds = grpc.credentials.createInsecure();
        }
        if (!url) {
            url = "gs.fountainhead.cash:50051";
        }
        if (!options) {
            options = {
                "grpc.max_receive_message_length": -1,
            };
        }
        this.client = new graphsearchrpc_grpc_pb.GraphSearchServiceClient(url, creds, options);
    }
    GraphSearchClient.prototype.graphSearchFor = function (_a) {
        var _this = this;
        var hash = _a.hash, _b = _a.reversedHashOrder, reversedHashOrder = _b === void 0 ? true : _b, _c = _a.excludeList, excludeList = _c === void 0 ? [] : _c;
        var req = new graphsearchrpc_pb.GraphSearchRequest();
        if (reversedHashOrder) {
            req.setTxid(Buffer.from(new Uint8Array(hash.match(/.{1,2}/g).map(function (byte) { return parseInt(byte, 16); })).reverse()).toString("hex"));
        }
        else {
            req.setTxid(hash);
        }
        for (var _i = 0, excludeList_1 = excludeList; _i < excludeList_1.length; _i++) {
            var excl = excludeList_1[_i];
            if (reversedHashOrder) {
                req.addExcludeTxids(Buffer.from(new Uint8Array(excl.match(/.{1,2}/g).map(function (byte) { return parseInt(byte, 16); })).reverse()).toString("hex"));
            }
            else {
                req.addExcludeTxids(excl);
            }
        }
        return new Promise(function (resolve, reject) {
            _this.client.graphSearch(req, function (err, data) {
                if (err !== null) {
                    reject(err);
                }
                else {
                    resolve(data);
                }
            });
        });
    };
    GraphSearchClient.prototype.trustedValidationFor = function (_a) {
        var _this = this;
        var hash = _a.hash, _b = _a.reversedHashOrder, reversedHashOrder = _b === void 0 ? true : _b;
        var req = new graphsearchrpc_pb.TrustedValidationRequest();
        if (reversedHashOrder) {
            req.setTxid(Buffer.from(new Uint8Array(hash.match(/.{1,2}/g).map(function (byte) { return parseInt(byte, 16); })).reverse()).toString("hex"));
        }
        else {
            req.setTxid(hash);
        }
        return new Promise(function (resolve, reject) {
            _this.client.trustedValidation(req, function (err, data) {
                if (err !== null) {
                    reject(err);
                }
                else {
                    resolve(data);
                }
            });
        });
    };
    GraphSearchClient.prototype.getStatus = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.client.status(new graphsearchrpc_pb.StatusRequest(), function (err, data) {
                if (err !== null) {
                    reject(err);
                }
                else {
                    resolve(data);
                }
            });
        });
    };
    return GraphSearchClient;
}());
exports.GraphSearchClient = GraphSearchClient;
//# sourceMappingURL=client.js.map